-- DROP TABLES
DROP TABLE IF EXISTS Config;
DROP TABLE IF EXISTS SongPlaylist;
DROP TABLE IF EXISTS Song;
DROP TABLE IF EXISTS Playlist;
DROP TABLE IF EXISTS Album;
DROP TABLE IF EXISTS Artist;
DROP TABLE IF EXISTS Genre;

CREATE TABLE Genre(id INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY, name VARCHAR(255) NOT NULL, UNIQUE(name)); 

CREATE TABLE Artist(id INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY, name VARCHAR(255) NOT NULL, UNIQUE(name)); 

CREATE TABLE Album(id INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY, artistId INTEGER, name VARCHAR(255) NOT NULL, FOREIGN KEY (artistId) REFERENCES Artist(id)); 

CREATE TABLE Playlist(id INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY, name VARCHAR(255) NOT NULL, UNIQUE (name)); 

CREATE TABLE Song (id INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY, genreId INTEGER, albumId INTEGER, artistId INTEGER, track INTEGER, disc INTEGER, title VARCHAR(255) NOT NULL, year INTEGER, componist VARCHAR(255) NOT NULL, publisher VARCHAR(255) NOT NULL, originalArtist VARCHAR(255) NOT NULL, copyright VARCHAR(255) NOT NULL, url VARCHAR(255) NOT NULL, rating INTEGER, comment VARCHAR(255) NOT NULL, codec VARCHAR(255) NOT NULL, filename VARCHAR(255) NOT NULL, filesize INTEGER, length INTEGER, FOREIGN KEY (genreId) REFERENCES Genre(id), FOREIGN KEY (albumId) REFERENCES Album(id), FOREIGN KEY (artistId) REFERENCES Artist(id));

CREATE TABLE SongPlaylist(id INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY, sId INTEGER, pId INTEGER, songOrder INTEGER, FOREIGN KEY (sId) REFERENCES Song(id), FOREIGN KEY (pId) REFERENCES Playlist(id) ON DELETE CASCADE);

CREATE TABLE Config(key VARCHAR(255) NOT NULL PRIMARY KEY, value VARCHAR(255) NOT NULL);


/* Initial Values for Genre, Artist, and Album */
INSERT INTO Genre (id, name) VALUES (1, 'Unknown'); INSERT INTO Artist (id, name) VALUES (1, 'Unknown'); INSERT INTO Album (id, artistid,  name) VALUES (1, 1, 'Unknown');
INSERT INTO Song (id,genreId,albumId,artistId,disc,title,year,componist,publisher,originalArtist,copyright,url,rating,comment,codec,filename,filesize ,length)VALUES (1,1,1,1 ,1234 ,'title' , 1234 ,'componist' , 'publisher' , 'orginalArtist' , 'copyRight' , 'url' , 5, 'comment' ,'codec' ,'filename' ,12345 ,1234444 ); 
INSERT INTO Playlist (id , name ) VALUES (5,'rock')  ; 
INSERT INTO SongPlaylist(id , sId,pId ,songOrder) VALUES(1,1,5,5) ; 

